var EXTENSION_CONNECT_LIST = '.list'; //ڑXgt@Cgq
var DISPLAY_ERROR_MAX = 10;

var lastModified = null;
var errorList = null;
var result = null;
var paramValue = null;
var selectdLine = null;

var connectList = new ListSet();
var unescapePath = unescape(window.location.pathname);
var fileBaseName = fileSystem.fso.BuildPath(fileSystem.fso.GetParentFolderName(unescapePath),
				   fileSystem.fso.GetBaseName(unescapePath));
var chiper = new ChiperAlphaNumMark();

function ConnectData(newDsn, newUid, newPwd, newMemo) {
	//w肳ĂȂundefinedݒ肳
	this.dsn = newDsn;
	this.uid = newUid;
	this.pwd = newPwd;
	this.memo = newMemo;
	trElement = null;
}
function initialize() {
	checkArgs();
	readConnectList(fileBaseName + EXTENSION_CONNECT_LIST);
	buildTable();
	if (connectList.size()) {
		if (paramValue) {
			var key = getConnectKey(paramValue.dsn, paramValue.uid);
			if (connectList.exists(key)) {
				setSelectedSub(document.getElementById(key));
			} else {
				setSelectedSub(document.getElementById(connectList.getItem(0).key));
			}
		} else {
			setSelectedSub(document.getElementById(connectList.getItem(0).key));
		}
	} else {
		selectdLine = null;
		buttonControl();
	}
}
function closeDialog() {
	if (!selectdLine) return;
	var data = connectList.getValue(selectdLine.id);
	var dsnText = data.dsn;
	var uidText = data.uid;
	var pwdText = data.pwd;
	var memoText= data.memo;
	result = dsnText + "\t" + uidText + "\t" + pwdText + "\t" + memoText;
	window.close();
}
function checkArgs() {

	//Oʂnꂽ擾
	var arg = window.dialogArguments;
	if (arg) {
		//OʂnꂽIuWFNg͔jĂ܂̂ŌXɑޔ
		paramValue = new Object();
		paramValue.dsn = (arg.dsn ? arg.dsn : '');
		paramValue.uid = (arg.uid ? arg.uid : '');
		btnCancel.value = 'LZ';
	} else {
		btnOk.style.display = 'none';
		btnOk.disabled = true;
		btnCancel.value = '';
		window.resizeTo(420,240);
	}
}
function getLastModifiedText(file) {
	return '' + file.DateLastModified;
}
function makeBackup(fileName) {
	var msg;
	try {
		var folderName = fileSystem.fso.BuildPath(fileSystem.fso.GetParentFolderName(unescapePath), 'backup');
		if (!fileSystem.fso.FolderExists(folderName)) {
			msg = 'obNAbvtH_쐬';
			fileSystem.fso.CreateFolder(folderName);
		}
		msg = 'ڑXg̃obNAbvtH_ւ̃Rs[';
		fileSystem.fso.CopyFile(fileName, folderName + '\\ڑXg_' + editDateForBackupFile(new Date()) + '.txt');
		return true;
	} catch(e) {
		alert(msg + 'ŃG[܂\n(' + e.description + ')');
		return false;
	}
}
function editDateForBackupFile(date) {
	var yy = date.getFullYear();
	var mm = date.getMonth() + 1;
	var dd = date.getDate();
	var hh = date.getHours();
	var mn = date.getMinutes();
	var sec = date.getSeconds();
	var msec= date.getMilliseconds();
	if (mm < 10) { mm = '0' + mm; }
	if (dd < 10) { dd = '0' + dd; }
	if (hh < 10) { hh = '0' + hh; }
	if (mn < 10) { mn = '0' + mn; }
	if (sec< 10) { sec= '0' + sec; }
	return yy + mm + dd  + '_' +
		   hh + mn + sec + '_' +
		   msec;
}
function writeConnectList(fileName, msg) {
	var result = false;
	var first = false;
	if (!fileSystem.fso.FileExists(fileName)) {
		fileSystem.fso.CreateTextFile(fileName);
		lastModified = getLastModifiedText(fileSystem.fso.GetFile(fileName));
		first = true;
	}
	var file = fileSystem.fso.GetFile(fileName);
	var nowLastModified = getLastModifiedText(file);
	if (lastModified != nowLastModified) {
		var res = confirm('ڑXgt@C͑̑ɂύXĂ܂B\n㏑Ă낵łH');
		if (!res) {
			alert('LZ܂B\ñEChEđ삵ȂĂB');
			return result;
		}
	}
	if (!first) { //񏑂݈ȊOȂobNAbv쐬
		if (!makeBackup(fileName)) return result;
	}
	try {
		stream = file.OpenAsTextStream(fileSystem.ioMode.ForWriting, fileSystem.format.TristateUseDefault);
		var readLineArray;
		for (var i=0 ; i<connectList.size() ; i++) {
			var data = connectList.getItem(i).val;
			readLineArray = data.dsn + '\t' + data.uid + '\t' + chiper.encode(data.pwd) + '\t' + data.memo;
			stream.WriteLine(readLineArray);
		}
		result = true;
	} catch(e) {
		alert(e.description);
	} finally {
		if (stream) {
			stream.Close();
		}
		lastModified = getLastModifiedText(file);
		return result;
	}
}
function readConnectList(fileName) {
	errorList = new Array();
	connectList.removeAll();
	var ERR_MSG = 'ڑXg̓es: ';
	lastModified = null;
	if (fileSystem.fso.FileExists(fileName)) {
		var stream;
		var line = null;
		try {
			var file = fileSystem.fso.GetFile(fileName);
			stream = file.OpenAsTextStream(fileSystem.ioMode.ForReading, fileSystem.format.TristateUseDefault);
			var readLineArray;
			var count = 0;
			while (!stream.AtEndOfStream) {
				count++;
				line = stream.ReadLine();
				if (!line) {
					errorList.push(count + ': f[^܂');
					continue;
				}
				readLineArray = line.split('\t');
				if (readLineArray.length < 3) {
					errorList.push(count + ': vfsł - ' + eadLineArray.length);
					continue;
				}
				var dsn = readLineArray[0];
				var uid = readLineArray[1];
				var pwd = readLineArray[2] = chiper.decode(readLineArray[2]);
				if (!dsn) {
					errorList.push(count + ': f[^\[X܂');
					continue;
				}
				if (!uid) {
					errorList.push(count + ': [UID܂');
					continue;
				}
				if (!pwd) {
					errorList.push(count + ': pX[h܂');
					continue;
				}
				var key = getConnectKey(dsn, uid);
				if (connectList.exists(key)) {
					errorList.push(count + ': df[^ł');
				} else {
					var memo = '';
					if (readLineArray.length > 3) {
						memo = readLineArray[3];
					}
					var data = new ConnectData(dsn, uid, pwd, memo);
					data.trElement = createTableLineObject(dsn, uid, memo);
					connectList.add(key, data);
				}
			}
		} catch(e) {
			alert(e.description);
		} finally {
			if (stream) {
				stream.Close();
			}
			lastModified = getLastModifiedText(file);
		}
	} else {
		fileSystem.fso.CreateTextFile(fileName);
		lastModified = getLastModifiedText(fileSystem.fso.GetFile(fileName));
	}
	displayErrorMessage('G[̔ȉ̃f[^͖܂B');
}
//G[΁Ǎ܂Ń_CAOɕ\
function displayErrorMessage(message) {
	if (errorList.length == 0) { return; }
	var msg = message + '\n';
	for (var i=0 ; i<errorList.length ; i++) {
		if (i >= DISPLAY_ERROR_MAX) {
			msg += '\n\n(' + (errorList.length-1) + ')';
			break;
		}
		msg += '\n\t' + errorList[i];
	}
	alert(msg);
}
function runOkProc() {
	if (event.srcElement.tagName == 'INPUT') {
		if (event.srcElement.type == 'text' || event.srcElement.type == 'password') {
			closeDialog();
		}
	}
}
function keyDownProc() {
	switch (event.keyCode) {
		case KeyCode.ENTER:
			if (!btnOk.disabled) runOkProc();
			break;
		case KeyCode.F5:
			break;
		case KeyCode.ESCAPE:
			window.close();
		default:
			return true;
	}

	//̃Cxgʗvf̃CxgnhɓnȂ
	event.cancelBubble = true;

	//L[͂ɂ{̃Cxg̔}
	event.returnValue = false;
	return false;
}
// ڑXgf[^ɁA\f[^č\z
function buildTable() {
	var listTable = document.getElementById('list');
	var tbody = listTable.getElementsByTagName('tbody')[0];
	while (tbody.hasChildNodes()) { //qvfΑS폜
		tbody.removeChild(tbody.childNodes.item(0));
	}
	var trClass = 'select';
	for (var i=0 ; i<connectList.size() ; i++) {
		var data = connectList.getItem(i).val;
		tbody.appendChild(data.trElement);
	}
}
// w肳ꂽDSNUIDŁAڑXgŎgL[𐶐ĕԂ
function getConnectKey(dsn, uid) {
	return dsn + '_' + uid;
}
// \p̍sIuWFNg𐶐ĕԂ
function createTableLineObject(dsn, uid, memo) {
	var tr = document.createElement('TR');
	tr.onclick = setSelected;
	tr.ondblclick = dblClickProc;
	tr.id = getConnectKey(dsn, uid);
	tr.appendChild(createCellObject(dsn, 'dsn'));
	tr.appendChild(createCellObject(uid, 'uid'));
	tr.appendChild(createCellObject(memo,'memo'));
	return tr;
}
// \p̃ZIuWFNg𐶐ĕԂ
function createCellObject(data, kind) {
	var td = document.createElement('TD');
	td.kind = kind;
	td.appendChild(document.createTextNode(data));
	return td;
}
function dblClickProc() {
	if (!btnOk.disabled) closeDialog();
}
// NbNsIsƂ
function setSelected() {
	var obj = event.srcElement; //srcElementTD
	setSelectedSub(obj.parentNode); //eTRn
}
function setSelectedSub(obj) {
	if (selectdLine) {
		selectdLine.className = '';
	}
	selectdLine = obj;
	selectdLine.className = 'select';
	buttonControl();
}
// ǉEҏWE폜{^̎gpې
function buttonControl() {
	if (selectdLine) {
		btnDel.disabled = false;
		btnEdit.disabled = false;
		if (btnOk.style.display != 'none') btnOk.disabled = false;
	} else {
		btnDel.disabled = true;
		btnEdit.disabled = true;
		btnOk.disabled = true;
	}
}
// ڑݒ_CAOɓnҏW
function setArgsForConnectDialog(changeDSN, changeUID) {
	var args = new Object();
	args.changeDSN = changeDSN;
	args.changeUID = changeUID;
	if (selectdLine) {
		var data = connectList.getValue(selectdLine.id);
		args.dsn = data.dsn;
		args.uid = data.uid;
		args.pwd = data.pwd;
		args.memo= data.memo;
	} else {
		args.dsn = '';
		args.uid = '';
		args.pwd = '';
		args.memo= '';
	}
	return args;
}
// ڑݒ_CAO\
function showConnectDialog(args) {
	return window.showModalDialog(
		'ConnectDialog.hta',
		args,
		'dialogHeight:190px;dialogWidth:350px;dialogLeft:100;dialogTop;100'
	);
}
// ǉ{^Bڑݒ̒ǉsȂ
function addItemProc() {
	var args = setArgsForConnectDialog(true, true);
	var result = showConnectDialog(args);
	if (result == null) return;

	var items = result.split('\t');
	key = getConnectKey(items[0], items[1]);
	if (connectList.exists(key)) {
		alert('̐ڑݒ͊ɓo^Ă܂B\n(pX[hAlύXꍇ́uҏWv{^𗘗pĂ)');
		return;
	}
	var data = new ConnectData(items[0], items[1], items[2], items[3]);
	connectList.add(key, data);
	var writeOk = writeConnectList(fileBaseName + EXTENSION_CONNECT_LIST, 'ڑݒ̒ǉ');
	if (!writeOk) {
		connectList.remove(key);
		return;
	}
	var tbody = document.getElementById('list').getElementsByTagName('tbody')[0];
	var tr = createTableLineObject(data.dsn, data.uid, data.memo);
	data.trElement = tr;
	tbody.appendChild(tr);
	setSelectedSub(tr);
}
// 폜{^BI𒆂̐ڑݒ̍폜sȂ
function delItemProc() {
	if (!selectdLine) return;
	var key = selectdLine.id;
	var index = connectList.getIndex(key);
	var item  = connectList.getItem(key);
	var res = confirm('If[^폜Ă낵łH');
	if (!res) return;
	connectList.remove(key);
	var writeOk = writeConnectList(fileBaseName + EXTENSION_CONNECT_LIST, 'ڑݒ̍폜');
	if (!writeOk) {
		connectList.insert(index, key, item); //폜L[̕
		return;
	}
	buildTable();
	if (connectList.size()) {
		if (index < connectList.size()) {
			setSelectedSub(document.getElementById(connectList.getItem(index).key));
		} else {
			setSelectedSub(document.getElementById(connectList.getItem(connectList.size()-1).key));
		}
	} else {
		selectdLine = null;
		buttonControl();
	}
}
// ҏW{^BI𒆂̐ڑݒ̃pX[hAl̕ҏWsȂ
function editItemProc() {
	var args = setArgsForConnectDialog(false, false);
	var result = showConnectDialog(args);
	if (result == null) return;

	var items = result.split('\t');
	key = getConnectKey(items[0], items[1]);
	if (!connectList.exists(key)) {
		alert('̐ڑݒ͓o^Ă܂B\n(f[^̏ԂsłB̃EChEđ삵ȂĂ)');
		return;
	}
	var data = connectList.getValue(key);
	var oldPwd = data.pwd;
	var oldMemo= data.memo;
	data.pwd = items[2];
	data.memo= items[3];
	var writeOk = writeConnectList(fileBaseName + EXTENSION_CONNECT_LIST, 'ڑݒ̍XV');
	if (!writeOk) {
		data.pwd = oldPwd;
		data.memo= oldMemo;
		return;
	}
	updateLineMemo(data.trElement, data.memo);
	buildTable();
	setSelectedSub(data.trElement);
}
function updateLineMemo(tr, memo) {
	var td = tr.childNodes.item(tr.childNodes.length-1);
	if (!td) return;
	if (td.kind != 'memo') return;
	if (td.hasChildNodes()) {
		td.childNodes.item(0).data = memo;
	}
}
//for debug
function printProperties(obj) {
	var s = '';
	for (var name in obj) {
		s += '[' + name + ']' + obj[name];
	}
	alert(s);
}
