/*********************************************************************
 * pipLjȈՈÍNXB
 *
 * Íł镶́AUnicodeR[hl0x20`0x7e͈͓̔ƂB
 * ܂艺L̂݁̕B
 * !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~
 * -------------------------------------------------------------------
 * 2014/06/07 
 * -------------------------------------------------------------------
 * Copyright(C) 2014 ASANO Sei (http://sei.qee.jp/docs/)
 *********************************************************************/
//**Start Encode**
function ChiperAlphaNumMark() {
	this.MIN = 0x20; //32
	this.MAX = 0x7e; //126
	this.GAP = this.MAX - this.MIN - 1;
	this.table = this.makeTable();
	this.table += this.table;
}
// Vtge[u쐬
ChiperAlphaNumMark.prototype.makeTable = function() {
	var str = '';
	for (var i=this.MIN ; i<=this.MAX ; i++) {
		str += String.fromCharCode(i);
	}
	return str;
}
// w̕񂪃pX[hɎg镶͈̔͂ɂ邩`FbN
ChiperAlphaNumMark.prototype.isValidLetterForPassword = function(text) {
	if (!text) return true;
	var letter;
	for (var i=0 ; i<text.length ; i++) {
		if (this.table.indexOf(text.charAt(i)) == -1) {
			return false;
		}
	}
	return true;
}
// w̕ÍBÍłȂ΋󕶎Ԃ
ChiperAlphaNumMark.prototype.encode = function(text) {

	if (!text) return '';
	if (!this.isValidLetterForPassword(text)) return '';

	var shiftVal = Math.floor(Math.random() * this.GAP) + 1;
	var shiftValHex = shiftVal.toString(16);
	if (shiftValHex.length < 2) shiftValHex = '0' + shiftValHex;

	var s = '';
	var index;
	for (i=(text.length-1) ; i>=0 ; i--) {
		index = text.charCodeAt(i) + shiftVal - this.MIN;
		s += this.table.substr(index, 1);
	}
	return '' + shiftValHex + s;
}
// Íꂽ𕜍BłȂ΋󕶎Ԃ
ChiperAlphaNumMark.prototype.decode = function(text) {

	if (!text) return '';
	if (text.length <= 2) return '';

	var shiftValHex = text.substr(0, 2);
	var shiftVal = new Number('0x' + shiftValHex);
	if (isNaN(shiftVal)) return '';
	if (shiftVal < 1) return '';
	if (shiftVal > (this.GAP + 1)) return '';

	var s = '';
	var index;
	for (i=(text.length-1) ; i>=2 ; i--) {
		index = this.table.indexOf(text.charAt(i), shiftVal) - shiftVal;
		s += this.table.substr(index, 1);
	}
	return s;
}
//eXgpR[h
function ChiperAlphaNumMark_test() {
	var chiper = new ChiperAlphaNumMark();
	var passwordList = [
		 ":;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`"
		,"aaabbbcccddd"
		,"[\]^_`"
		,"abc^_`"
	];
	for (var i=0 ; i<passwordList.length ; i++) {
		var pw = passwordList[i];
		if (chiper.isValidLetterForPassword(pw)) {
			var encodePw = chiper.encode(pw);
			var decodePw = chiper.decode(encodePw);
			WScript.Echo(pw + '\n\tpX[hɎg镶: Yes');
			WScript.Echo('\tencode: ' + encodePw + '\n\tdecode: ' + decodePw + '\n\t' + (pw == decodePw ? 'OK' : 'NG'));
		} else {
			WScript.Echo(pw + '\n\tpX[hɎg镶: No');
		}
	}
}
//ChiperAlphaNumMark_test();
