/*********************************************************************
 * L[ƒl̑gݍ킹œo^ł郊XgEListSetNXB
 * vfNXListSetItemB
 * -------------------------------------------------------------------
 * 2014/06/07 
 * -------------------------------------------------------------------
 * Copyright(C) 2014 ASANO Sei (http://sei.qee.jp/docs/)
 *********************************************************************/
//**Start Encode**
/*********************************************************************
 * ListSet̗vfpNX
 * -------------------------------------------------------------------
 * [] key : L[
 *        val : l
 *********************************************************************/
function ListSetItem(key, val) {
	this.key = key;
	this.val = val;
 	this.toString = function() {
 		return '[key=' + this.key + ', val=' + this.val + ']';
 	}
}
/*********************************************************************
 * ListSetNX
 * -------------------------------------------------------------------
 * [] Ȃ
 *********************************************************************/
function ListSet() {
	this.items = new Array();
	this.keyCollection = new Object();
	this.size = function() { return this.items.length; }
}
/*-------------------------------------------------------------------*
 * w肵L[̒ɐVvf}
 * -------------------------------------------------------------------
 * [] key       : L[
 *        insertKey : }vf̃L[
 *        val       : }vf̒l
 * [߂] Ȃ
 * [O] w肵L[݂ȂA}vf̃L[ɑ݂鎞
 *-------------------------------------------------------------------*/
ListSet.prototype.insertAfter = function(key, insertKey, val) {
	if (this.notExists(key)) {
		throw this.getErrorMessage_notExists('insertAfter', key);
	}
	if (this.exists(insertKey)) {
		throw this.getErrorMessage_alreadyExists('insertAfter', insertKey);
	}
	var index = this.getIndex(key);
	this.insert(++index, insertKey, val);
}
/*-------------------------------------------------------------------*
 * w肵L[̒OɐVvf}
 * -------------------------------------------------------------------
 * [] key       : L[
 *        insertKey : }vf̃L[
 *        val       : }vf̒l
 * [߂] Ȃ
 * [O] w肵L[݂ȂA}vf̃L[ɑ݂鎞
 *-------------------------------------------------------------------*/
ListSet.prototype.insertBefore = function(key, insertKey, val) {
	if (this.notExists(key)) {
		throw this.getErrorMessage_notExists('insertBefore', key);
	}
	if (this.exists(insertKey)) {
		throw this.getErrorMessage_alreadyExists('insertBefore', insertKey);
	}
	var index = this.getIndex(key);
	this.insert(index, insertKey, val);
}
/*-------------------------------------------------------------------*
 * w肵CfbNXʒuɐVvf}
 * -------------------------------------------------------------------
 * [] index     : }ʒu
 *        insertKey : }vf̃L[
 *        val       : }vf̒l
 * [߂] Ȃ
 * [O] CfbNXI[o[A}vf̃L[ɑ݂鎞
 *-------------------------------------------------------------------*/
ListSet.prototype.insert = function(index, key, val) {
	if ((index < 0) || (this.size() < index)) {
		throw this.getErrorMessage_overIndex('insertItem', index, this.size());
	}
	if (this.size() == index) { //Ōɒǉꍇadd\bhŏ
		this.add(key, val);
		return;
	}
	if (this.exists(key)) {
		throw this.getErrorMessage_alreadyExists('insertItem', key);
	}
	var idx = this.keyCollection[key];
	for (var i=this.items.length ; i>index ; i--) {
		this.items[i] = this.items[i-1]; //O̗vfݒ
		this.keyCollection[this.items[i].key]++;
	}
	this.keyCollection[key] = index;
	this.items[index] = new ListSetItem(key, val);
}
/*-------------------------------------------------------------------*
 * w肵CfbNXʒu̗vfԂ
 * -------------------------------------------------------------------
 * [] index     : CfbNX
 * [߂] Ȃ
 * [O] CfbNXI[o[
 *-------------------------------------------------------------------*/
ListSet.prototype.getItem = function(index) {
	if ((index < 0) || (this.size() <= index)) {
		throw this.getErrorMessage_overIndex('getItem', index, this.size()-1);
	}
	return this.items[index];
}
/*-------------------------------------------------------------------*
 * w肵L[̃CfbNXʒuԂ
 * -------------------------------------------------------------------
 * [] key       : L[
 * [߂] Ȃ
 * [O] L[݂Ȃ
 *-------------------------------------------------------------------*/
ListSet.prototype.getIndex = function(key) {
	if (this.notExists(key)) {
		throw this.getErrorMessage_notExists('getIndex', key);
	}
	return this.keyCollection[key];
}
/*-------------------------------------------------------------------*
 * w肵L[̒lԂ
 * -------------------------------------------------------------------
 * [] key       : L[
 * [߂] Ȃ
 * [O] L[݂Ȃ
 *-------------------------------------------------------------------*/
ListSet.prototype.getValue = function(key) {
	if (this.notExists(key)) {
		throw this.getErrorMessage_notExists('getValue', key);
	}
	var idx = this.keyCollection[key];
	return this.items[idx].val;
}
/*-------------------------------------------------------------------*
 * w肵L[̒lݒ肷
 * -------------------------------------------------------------------
 * [] key       : L[
 *        val       : l
 * [߂] Ȃ
 * [O] L[݂Ȃ
 *-------------------------------------------------------------------*/
ListSet.prototype.set = function(key, val) {
	if (this.notExists(key)) {
		throw this.getErrorMessage_notExists('set', key);
	}
	var idx = this.keyCollection[key];
	this.items[idx].val = val;
}
/*-------------------------------------------------------------------*
 * w肵L[̗vf폜
 * -------------------------------------------------------------------
 * [] key       : L[
 * [߂] Ȃ
 * [O] L[݂Ȃ
 *-------------------------------------------------------------------*/
ListSet.prototype.remove = function(key) {
	if (this.notExists(key)) {
		throw this.getErrorMessage_notExists('remove', key);
	}
	var idx = this.keyCollection[key];
	for (var i=idx ; i<(this.items.length-1) ; i++) {
		this.items[i] = this.items[i+1];
		this.keyCollection[this.items[i].key]--;
	}
	this.keyCollection[key] = undefined;
	this.items = this.items.slice(0, this.items.length-1);
}
/*-------------------------------------------------------------------*
 * SĂ̗vf폜
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] Ȃ
 *-------------------------------------------------------------------*/
ListSet.prototype.removeAll = function() {
	this.items = new Array();
	this.keyCollection = Object;
}
/*-------------------------------------------------------------------*
 * w肵L[ƒlŁAɗvfǉ
 * -------------------------------------------------------------------
 * [] key       : L[
 *        val       : l
 * [߂] Ȃ
 * [O] w肵L[ɑ݂鎞
 *-------------------------------------------------------------------*/
ListSet.prototype.add = function(key, val) {
	if (this.exists(key)) {
		throw this.getErrorMessage_alreadyExists('add', key);
	}
	this.items.push(new ListSetItem(key, val));
	this.keyCollection[key] = (this.items.length - 1);
}
/*-------------------------------------------------------------------*
 * w肵L[݂邩`FbN
 * -------------------------------------------------------------------
 * [] key       : L[
 * [߂] w肵L[݂鎞true
 *-------------------------------------------------------------------*/
ListSet.prototype.exists = function(key) {
	return !this.notExists(key);
}
/*-------------------------------------------------------------------*
 * w肵L[݂Ȃ`FbN
 * -------------------------------------------------------------------
 * [] key       : L[
 * [߂] w肵L[݂Ȃtrue
 *-------------------------------------------------------------------*/
ListSet.prototype.notExists = function(key) {
	return (this.keyCollection[key] == undefined);
}
/*-------------------------------------------------------------------*
 * CfbNXI[o[p̃G[bZ[WԂ
 * -------------------------------------------------------------------
 * [] caller    : Ăяo
 *        index     : I[o[CfbNXl
 *        maxIndex  : CfbNX̍ől
 * [߂] CfbNXI[o[p̃G[bZ[W
 *-------------------------------------------------------------------*/
ListSet.prototype.getErrorMessage_overIndex = function(caller, index, maxIndex) {
	return 'i' + caller + 'j' + index + '̓CfbNXI[o[łB0`' + maxIndex + 'w肵Ă';
}
/*-------------------------------------------------------------------*
 * L[݂Ȃ̃G[bZ[WԂ
 * -------------------------------------------------------------------
 * [] caller    : Ăяo
 *        key       : L[
 * [߂] L[݂Ȃ̃G[bZ[W
 *-------------------------------------------------------------------*/
ListSet.prototype.getErrorMessage_notExists = function(caller, key) {
	return 'i' + caller + 'jL[' + key + '݂͑܂B';
}
/*-------------------------------------------------------------------*
 * L[݂鎞̃G[bZ[WԂ
 * -------------------------------------------------------------------
 * [] caller    : Ăяo
 *        key       : L[
 * [߂] L[݂鎞̃G[bZ[W
 *-------------------------------------------------------------------*/
ListSet.prototype.getErrorMessage_alreadyExists = function(caller, key) {
	return 'i' + caller + 'jL[' + key + '͊ɑ݂܂B';
}
/*-------------------------------------------------------------------*
 * ׂĂ̗vfeLXgŕԂ
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] ׂĂ̗vf̕
 *-------------------------------------------------------------------*/
ListSet.prototype.dumpAllItems = function() {
	var lines = new Array();
	for (var i=0 ; i<this.size() ; i++) {
		var item = this.getItem(i);
		lines.push(i + ':\t' + this.getIndex(item.key) + '\t' + this.getItem(i));
	}
	return lines.join('\n');
}

/***********************************************************
 * ȉAeXgpR[h
 ***********************************************************/
function ListSet_showMessage(msg) {
	//̃Rg͂ۂCommon.jsK{B܂͂̓sxAWScript.Echoalertg
	/*
	if (common.isWsh) {
		WScript.Echo(msg);
	} else {
		alert(msg);
	}
	*/
}
function ListSet_editErrorMessage(e) {
	var result = '';
	if (e.number) result += '[' + e.number + '] ';
	if (e.description) result += e.description;
	if (!result) result = '' + e;
	return result;
}
function ListSet_test() {
	var list = new ListSet();
	try {
		list.add('bbb','val1');
		//list.add('bbb','val1b');
		list.add('aaa','val2');
		list.add('ccc','val3');
		//list.insert(-1, 'a', 'insert0');
		list.insertAfter('aaa', 'after aaa', 'insert1');
		list.insertBefore('aaa', 'before aaa', 'insert2');
		list.set('after aaa', 'set');
		ListSet_showMessage('size: ' + list.size());
	} catch(e) {
		ListSet_showMessage( ListSet_editErrorMessage(e));
	}
	try {
		ListSet_showMessage(list.dumpAllItems());
	} catch(e) {
		ListSet_showMessage(ListSet_editErrorMessage(e));
	}
	ListSet_showMessage('End');
}
ListSet_test();
